' Attiny-Platine      Antonius Ewald, 04/2016
' Kanalschaletr 4 Kanle mit Menory
' fr Walter
' letzte nderung 24.11.2016
'----------------------------------------------------------------------------
'
$regfile = "attiny4313.dat"                                 'Attiny4313 4Kb
' $crystal = 14745600 / 8
$crystal = 1843200
' Interner Takt 1843200 Mhz
' Es wird ein Quartz mit 16 Mhz benutzt
' http://avrhelp.mcselec.com/index.html?config_timer1.htm
' http://rmc-sachsen.de/?nav=bascom-timer-berechnung
'**********************************************************
'******************* Deklarationen ************************
' 0 = Eingang
' 1 = Ausgang
Ddrb = &B11111111                                           'Port B 0 - 7 Ausgang
Ddrd = &B00000000                                           'Port D 2 - 5 Eingang Fersteuereung
Portd = &B00000010                                          'Eingnge auf high legen (PullUp)
Portb = &B00000000                                          'Ausgnge auf 0
'
' --- definiere Variable
'
Dim Puls_lenght As Byte                                     ' Pulslnge ist 8-20 ~ 0,8-2,0 msec
Dim Pause_lenght As Byte                                    ' Pause bis 20 msec
Dim Fl_in As Byte                                           ' Input von Empfnger
Dim Flr_out As Byte                                         ' Merker, Ausgang = 1
Dim Flr_mem As Byte                                         ' Merker Memory
Dim Flr_mem1 As Byte
Dim Sync_count As Byte                                      ' Pause beim ersten erkennen
Dim Kan1_lenght As Byte
Dim Kan2_lenght As Byte
Dim Kan3_lenght As Byte
Dim Kan4_lenght As Byte
Dim Temp As Byte
Dim Temp1 As Byte
Dim Msec As Word                                            'Zhler
Dim Ser_nr1 As String * 32
Dim Ser_nr2 As String * 32
'
' --- Definiere Voreinstellungen ---
'
'Baudrate fr UART
'
$baud = 9600
'
' -----------------------------------
' -- Timer0
'------------------------------------
'###[BASCOM-Timerberechnung von Michael Helmert, http://rmc-sachsen.de]###
'###http://www.rmc-sachsen.de/?nav=bascom-timer-berechnung
'
'Quarzfrequenz: 14.7456 MHz
'Gewnschte Zeit: 0.1 ms
'Erreichbare Zeit: 0.099826389 ms
'Abweichung: 0.17361 % bzw. 1736.11111 ppm
'
'Const Timer0_preload = 72
'
'Config Timer0 = Timer , Prescale = 8
'Enable Timer0
'Timer0 = Timer0_preload
'
'On Timer0 Isr_timer0
'Enable Interrupts
'Stop Timer0
' -----------------------------------
' -- Timer0
'------------------------------------
'Quarzfrequenz: 1.8432 MHz
'Gewnschte Zeit: 0.1 ms
'Erreichbare Zeit: 0.099826389 ms
'Abweichung: 0.17361 % bzw. 1736.11111 ppm

' Preload abweichend von Berechnung emphirisch ermittelt
' - 10 -- 15 -- 20
Const Timer0_preload = 130

Config Timer0 = Timer, Prescale = 1
Enable Timer0
Timer0 = Timer0_Preload
On Timer0 Isr_Timer0
Enable Interrupts
Stop Timer0
' -----------------------------------
' -- Timer1
'------------------------------------
'Quarzfrequenz: 14.7456 MHz
'Gewnschte Zeit: 1 ms
'Erreichbare Zeit: 1.00002713 ms
'Abweichung: 0.00271 % bzw. 27.12674 ppm
'
'Const Timer1_preload = 50790
''
'Config Timer1 = Timer , Prescale = 1
'Enable Timer1
'Timer1 = Timer1_preload
'' On Ovf1 Isr_timer1
'On Timer1 Isr_timer1
'Enable Interrupts
'Stop Timer1
' -----------------------------------
' -- Timer1
'------------------------------------
'Quarzfrequenz: 1.8432 MHz
'Gewnschte Zeit: 1 ms
'Erreichbare Zeit: 0.99989149 ms
'Abweichung: 0.01085 % bzw. 108.50694 ppm


Const Timer1_Preload = 63693

Config Timer1 = Timer, Prescale = 1
Enable Timer1
Timer1 = Timer1_Preload
On Timer1 Isr_Timer1
Enable Interrupts
Stop Timer1
'------------------------------------
' --- Zuordung der Ports ---
'
Kan_1 Alias Pind.2                                          ' Inputs werden mit 'PINXX' gelesen
Kan_2 Alias Pind.3                                          ' 4 Kanle einlesen
Kan_3 Alias Pind.4                                          ' die 4 Impulse starten alle gleichzeitig
Kan_4 Alias Pind.5
'
Out_1a Alias Portb.0                                        ' Taster 1 Richtung vorne
Out_1b Alias Portb.1                                        ' Taster 1 Richtung hinten
Out_2a Alias Portb.2
Out_2b Alias Portb.3
Out_3a Alias Portb.4
Out_3b Alias Portb.5
Out_4a Alias Portb.6
Out_4b Alias Portb.7
'
' --- Flagregister, Flags definieren ---
'
Fl_out_1a Alias Flr_out.0                                   ' Merker, ob Ausgang gesetzt
Fl_out_1b Alias Flr_out.1
Fl_out_2a Alias Flr_out.2
Fl_out_2b Alias Flr_out.3
Fl_out_3a Alias Flr_out.4
Fl_out_3b Alias Flr_out.5
Fl_out_4a Alias Flr_out.6
Fl_out_4b Alias Flr_out.7
'
Fl_mem_1a Alias Flr_mem.0                                   ' Memory Bit
Fl_mem_1b Alias Flr_mem.1
Fl_mem_2a Alias Flr_mem.2
Fl_mem_2b Alias Flr_mem.3
Fl_mem_3a Alias Flr_mem.4
Fl_mem_3b Alias Flr_mem.5
Fl_mem_4a Alias Flr_mem.6
Fl_mem_4b Alias Flr_mem.7
'
Fl_mem1_1a Alias Flr_mem1.0                                 ' Memory Bit
Fl_mem1_1b Alias Flr_mem1.1
Fl_mem1_2a Alias Flr_mem1.2
Fl_mem1_2b Alias Flr_mem1.3
Fl_mem1_3a Alias Flr_mem1.4
Fl_mem1_3b Alias Flr_mem1.5
Fl_mem1_4a Alias Flr_mem1.6
Fl_mem1_4b Alias Flr_mem1.7
'
Fl_in1 Alias Fl_in.0                                        ' Merker fr Eingnge
Fl_in2 Alias Fl_in.1
Fl_in3 Alias Fl_in.2
Fl_in4 Alias Fl_in.3

' Impuls 1,0 msec = Kurz
' Impuls 1,5 msec = Mitte
' Impuls 2,0 msec = Lang
Const Imp_short_low = 7                                     ' 0,8 - 1,2 msec
Const Imp_short_high = 13
Const Imp_mid_low = 13                                      ' 1,4 - 1,7 msec
Const Imp_mid_high = 18
Const Imp_long_low = 18                                     ' 1,9 - 2,2 msec
Const Imp_long_high = 23
'
'****************** Initialisierung ***********************
'
Flr_out = 0
Flr_mem = 0
Flr_mem1 = 0
Fl_in = 0                                                   ' lsche alle Flags
Msec = 0
Reset Out_1a                                                'setze all Ausgnge auf 0
Reset Out_1b
Reset Out_2a
Reset Out_2b
Reset Out_3a
Reset Out_3b
Reset Out_4a
Reset Out_4b
'
Sync_count = 0
'
'******************** Hauptprogramm ***********************
' Beginne mit der Abfrage der Pause
'**********************************************************
Main:
'
Wait_for_sync:                                              ' Syncronisierung auf Pause
'
Pause_lenght = 0                                            ' Zhler zu 0
Timer1 = Timer1_preload                                     ' 1ms
Start Timer1
Wait_sync:
'
If Kan_1 = 0 Then
   If Pause_lenght < 10 Then                                ' die Pause betrgt max ca 18 msec
   Goto Wait_sync
   End If
   If Pause_lenght > 25 Then
      Goto Wait_for_sync
   End If                                                   ' > 20, Verwerfen
End If                                                      ' Sync Pause erkannt
'
Stop Timer1
'
' warte nun auf steigende Flanke
' alle 4 Kanle gehen gleichzeitig auf High
' Lsche zunchst alle bentigten Speicher
'
Wait_imp:
Fl_in = 0
Puls_lenght = 0
Kan1_lenght = 0
Kan2_lenght = 0
Kan3_lenght = 0
Kan4_lenght = 0
'
Wait_imp1:
If Kan_1 = 0 Then
   Goto Wait_imp1
End If                                                      'warte auf steigende Flanke
'------------------------------------------------------------
'nun haben wir ein High
'warte nun fr jeden Eingang auf fallende Flanke,
'bernehme Impulslnge aus Interrupt Zhler
'setze danach den Merker, damit das Ergebnis nicht berschrieben wird
'------------------------------------------------------------
'
Timer0 = Timer0_preload                                     '0,1ms
Start Timer0                                                'starte die Messung
Test_kan1:
   If Fl_in1 = 1 Then : Goto Test_kan2 : End If
   If Kan_1 = 0 Then : Kan1_lenght = Puls_lenght : Set Fl_in1 : End If
'
Test_kan2:
   If Fl_in2 = 1 Then : Goto Test_kan3 : End If
   If Kan_2 = 0 Then : Kan2_lenght = Puls_lenght : Set Fl_in2 : End If
'
Test_kan3:
   If Fl_in3 = 1 Then : Goto Test_kan4 : End If
   If Kan_3 = 0 Then : Kan3_lenght = Puls_lenght : Set Fl_in3 : End If
'
   Test_kan4:
   If Fl_in4 = 1 Then : Goto Test_kan_end : End If
   If Kan_4 = 0 Then : Kan4_lenght = Puls_lenght : Set Fl_in4 : End If
Test_kan_end:
'
' alle Kanle erfasst ???
' Teste, ob alle 4 Flags gesetzt, sonst weiter messen.
'
If Fl_in < &B00001111 Then : Goto Test_kan1 : End If
Stop Timer0
'
' verwerfe die ersten 5 telegramme
If Sync_count < 5 Then : Incr Sync_count : Goto Wait_for_sync : End If
Sync_count = 10
'
'Print "Kanal 1: " ; Kan1_lenght;
'Print " Kanal 2: " ; Kan2_lenght;
'Print " Kanal 3: " ; Kan3_lenght;
'Print " Kanal 4: " ; Kan4_lenght
'Print "  Pause : " ; Sync_count
'Print
'------------------------------------------------------------
' jetzt das Ergebnis auswerten
' Impuls 1,0 msec = Kurz
' Impuls 1,5 msec = Mitte
' Impuls 2,0 msec = Lang
' Schalterstellung ermitteln
' Low = 1
' Mid = 0
' high = 2
' Ergebnis 1,0,2 in Temp1
'-------------------------------------
' Kanal 1a bearbeiten
'-------------------------------------
Temp = Kan1_lenght
Gosub Sub_imp_lenght
' Taster nach vorne
If Temp1 = 1 Then

' Ist der Ausgang aus, dann einschalten und Flag setzen
   If Fl_out_1a = 0 Then
      If Fl_mem1_1a = 0 Then : Set Fl_out_1a : Set Out_1a : End If
   End If                                                   ' ist Ausgang gesetzt ?
' ist Memory gesetzt, bei der nchsten Bettigung Ausgang lschen.
   If Fl_mem_1a = 1 Then
      Reset Fl_out_1a : Reset Fl_mem_1a : Set Fl_mem1_1a : Reset Out_1a
   End If                                                   ' ist Memory gesetzt, dann nichts machen
'
End If
'
' Kanal 1b bearbeiten
'
' Taster nach hinten
If Temp1 = 2 Then                                           ' Schalter = 2
' Ist der Ausgang aus, dann einschalten und Flag setzen
   If Fl_out_1b = 0 Then
      If Fl_mem1_1b = 0 Then : Set Fl_out_1b : Set Out_1b : End If
   End If                                                   ' ist Ausgang gesetzt ?
' ist Memory gesetzt, bei der nchsten Bettigung Ausgang lschen.
   If Fl_mem_1b = 1 Then
      Reset Fl_out_1b : Reset Fl_mem_1b : Set Fl_mem1_1b : Reset Out_1b
   End If
End If
' Wenn Output gesetzt, Memory Flag setzen
If Temp1 = 0 Then
   If Fl_out_1a = 1 Then
        Set Fl_mem_1a
   End If
   Reset Fl_mem1_1a
  '
   If Fl_out_1b = 1 Then
      Set Fl_mem_1b
   End If
   Reset Fl_mem1_1b
End If
'-------------------------------------
' Kanal 2a bearbeiten
'-------------------------------------
Temp = Kan2_lenght
Gosub Sub_imp_lenght
'
If Temp1 = 1 Then
'
   If Fl_out_2a = 0 Then
      If Fl_mem1_2a = 0 Then : Set Fl_out_2a : Set Out_2a : End If
   End If
'
   If Fl_mem_2a = 1 Then
      Reset Fl_out_2a : Reset Fl_mem_2a : Set Fl_mem1_2a : Reset Out_2a
   End If
'
End If
'
' Kanal 2b bearbeiten
'
If Temp1 = 2 Then
'
   If Fl_out_2b = 0 Then
      If Fl_mem1_2b = 0 Then : Set Fl_out_2b : Set Out_2b : End If
   End If
'
   If Fl_mem_2b = 1 Then
      Reset Fl_out_2b : Reset Fl_mem_2b : Set Fl_mem1_2b : Reset Out_2b
   End If
'
End If
'
If Temp1 = 0 Then
   If Fl_out_2a = 1 Then
      Set Fl_mem_2a
   End If
   Reset Fl_mem1_2a
   If Fl_out_2b = 1 Then
      Set Fl_mem_2b
   End If
   Reset Fl_mem1_2b
End If
'-------------------------------------
' Kanal 3a bearbeiten
'-------------------------------------
Temp = Kan3_lenght
Gosub Sub_imp_lenght
'
If Temp1 = 1 Then
'
   If Fl_out_3a = 0 Then
      If Fl_mem1_3a = 0 Then : Set Fl_out_3a : Set Out_3a : End If
   End If
'
   If Fl_mem_3a = 1 Then
      Reset Fl_out_3a : Reset Fl_mem_3a : Set Fl_mem1_3a : Reset Out_3a
   End If
 End If
'
' Kanal 3b bearbeiten
'
If Temp1 = 2 Then
'
If Fl_out_3b = 0 Then
      If Fl_mem1_3b = 0 Then : Set Fl_out_3b : Set Out_3b : End If
   End If
'
   If Fl_mem_3b = 1 Then
      Reset Fl_out_3b : Reset Fl_mem_3b : Set Fl_mem1_3b : Reset Out_3b
   End If
'
End If
'
If Temp1 = 0 Then
   If Fl_out_3a = 1 Then
      Set Fl_mem_3a
   End If
   Reset Fl_mem1_3a
   If Fl_out_3b = 1 Then
      Set Fl_mem_3b
   End If
   Reset Fl_mem1_3b
End If
'-------------------------------------
' Kanal 4a bearbeiten
'-------------------------------------
Temp = Kan4_lenght
Gosub Sub_imp_lenght
'
If Temp1 = 1 Then
'
   If Fl_out_4a = 0 Then
      If Fl_mem1_4a = 0 Then : Set Fl_out_4a : Set Out_4a : End If
   End If
'
   If Fl_mem_4a = 1 Then
      Reset Fl_out_4a : Reset Fl_mem_4a : Set Fl_mem1_4a : Reset Out_4a
   End If
 End If
'
' Kanal 4b bearbeiten
'
If Temp1 = 2 Then
'
If Fl_out_4b = 0 Then
      If Fl_mem1_4b = 0 Then : Set Fl_out_4b : Set Out_4b : End If
   End If
'
   If Fl_mem_4b = 1 Then
      Reset Fl_out_4b : Reset Fl_mem_4b : Set Fl_mem1_4b : Reset Out_4b
   End If
'
End If
'
If Temp1 = 0 Then
   If Fl_out_4a = 1 Then
      Set Fl_mem_4a
   End If
   Reset Fl_mem1_4a
   If Fl_out_4b = 1 Then
      Set Fl_mem_4b
   End If
   Reset Fl_mem1_4b
End If
'-------------------------------------
'
'Print "FLR_Out ";
'Print Fl_out_1a;
'Print Fl_out_1b;
'Print Fl_out_2a;
'Print Fl_out_2b;
'Print Fl_out_3a;
'Print Fl_out_3b;
'Print Fl_out_4a;
'Print Fl_out_4b;
'
'Print "  Flr_mem ";
'Print Fl_mem_1a ;
'Print Fl_mem_1b ;
'Print Fl_mem_2a ;
'Print Fl_mem_2b ;
'Print Fl_mem_3a ;
'Print Fl_mem_3b ;
'Print Fl_mem_4a ;
'Print Fl_mem_4b
'
'------------------------------------------------------------
'
' Pause einlegen 500 msec
':
'Timer1 = Timer1_preload
'msec = 0
'Start Timer1
'Wait_timer_100:
'   If Msec < 500 Then : Goto Wait_timer_100 : End If
'Stop Timer1
'
'Kanal_mess_end:
'jetzt geht's von vorne los
Goto Main
'------------------------------------------------------
' Unterprogramm wird 4  mal aufgerufen
'------------------------------------------------------
'
Sub_imp_lenght:
'
' gemessene Impulslnge in Temp
' Ergebnis 0,1,2 in Temp1
' Impuls 1,0 msec = Kurz --> 1
' Impuls 1,5 msec = Mitte--> 0
' Impuls 2,0 msec = Lang --> 2
' Const Imp_short_low = 7      '0,9 - 1,1 'auflsung 0,1 msec
'
' berprfe die Impulslnge innerhalb der Toleranzen
' vorausgesetzt die Timer Einstellungen stimmen
'
Sub_imp1:
'
If Temp > Imp_short_low And Temp < Imp_short_high Then : Temp1 = 1 : Goto Sub_imp_end : End If
'
If Temp > Imp_mid_low And Temp < Imp_mid_high Then : Temp1 = 0 : Goto Sub_imp_end : End If
'
If Temp > Imp_long_low And Temp < Imp_long_high Then : Temp1 = 2 : Goto Sub_imp_end : End If

' Temp enthlt 1 = Kurz
' Temp enthlt 0 = Mitte
' Temp enthlt 2 = Lang
'
' Sonst Fehler:
Temp = &HFF
Temp1 = &HFF
' Hier i.O.
Sub_imp_end:
Return

Goto Main:
'------------------------------------------------------
' Interrupt, wenn Timer 0 = OVL;
' Einstellung fr 0,1 msec zum Messsen der Impulszeit
'------------------------------------------------------
Isr_timer0:
Timer0 = Timer0_preload
Incr Puls_lenght
Return
'------------------------------------------------------
' Interrupt, wenn Timer 1 = OVL
' Initialisiert einen Zeit Zhler
' Eingestellt auf 1 msec zum Messen der Sync-Pausen
'------------------------------------------------------
Isr_timer1:
Timer1 = Timer1_preload
'Pause_lenght = Pause_lenght + 1                             'Timer Voreinstellung fr 1 msec.
Incr Pause_lenght
Incr Msec
'Incr Sync_count
'
'If Msec = 500 Then : Toggle Out_1a : End If
'
'If Msec < 1000 Then : Goto Uhr_end : End If
'Toggle Out_1a
'Msec = 0
'------------------------------------------------------
' Debugging
'------------------------------------------------------
' Output_txd:
' Print Flr_out , Flr,
' Print Pause_lenght , Puls_lenght
' Print "Sekunde " ; Sekunde ; "Minute "minute , "Stunde " ; Stunde
'------------------------------------------------------
' Debugging
'------------------------------------------------------

'Print " Sekunde: " ; Sekunde ; " Minute: " ; Minute ; " Stunde: " ; Stunde
'Print Minute
'Print Hex(sekunde) ; "   " ; Bin(sekunde)
'
'Incr Sekunde
'If Sekunde < 60 Then : Goto Uhr_end : End If
'Sekunde = 0
'Incr Minute
'
'Toggle Out_2a
'
'If Minute < 60 Then : Goto Uhr_end : End If
'Minute = 0
'Incr Stunde
'
'If Stunde < 24 Then : Goto Uhr_end : End If
'Stunde = 0
'
Uhr_end:
'
Return
'**********************************************************
Ser_nr1 = "Antonius Ewald 04/2016"
Ser_nr2 = "11/2016"